import 'dart:convert';
import 'dart:math';

import 'package:http/http.dart';
import 'package:rec_api_dart/rec_api_dart.dart';

class VIDchainService extends ServiceBase {
  VIDchainService({required EnvBase env, Client? client})
      : super(
          env: env,
          client: client,
          interceptors: [UserTokenInterceptor()],
        );

  Future getClientId(String id) async {
    //const url = "signatures";
    String nonce = _generarStringRandom(43);
    Map<String, dynamic> assertionBase = {
      "iss": "La Rosa Sant Feliu",
      "aud": "vidchain-api",
      "nonce": nonce,
      "apiKey": "01863bfe-5012-496e-bfaa-89259c4bb0e8"
    };

    String assertion = encodeToBase64(assertionBase);

    var payload = {
      "grantType": "urn:ietf:params:oauth:grant-type:jwt-bearer",
      "assertion": assertion,
      "scope": "vidchain profile entity",
      "expiresIn": 2592000
    };
    final path = ApiPaths.getAccesToken.asUri('staging.vidchain.net');
    return this.post(path, payload);
  }

  String _generarStringRandom(int elements) {
  const caracteres = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
  final random = Random();
  final buffer = StringBuffer();

  for (var i = 0; i < elements; i++) {
    final indiceAleatorio = random.nextInt(caracteres.length);
    buffer.write(caracteres[indiceAleatorio]);
  }

  return buffer.toString();
}

  String encodeToBase64(Map<String, dynamic> value) {
    String jsonString = json.encode(value);
    String encodedString = base64Url.encode(utf8.encode(jsonString));
    return encodedString;
  }
}










