
import 'package:http/http.dart';
import 'package:rec_api_dart/rec_api_dart.dart';

class CredentialsService extends ServiceBase {
  CredentialsService({required EnvBase env, Client? client})
      : super(
          env: env,
          client: client,
          interceptors: [UserTokenInterceptor()],
        );

  Future getCredential(String id) async {
    final uri = ApiPaths.getCredentials.append(id).asUri(env.API_URL);

    return this.get(uri).then((res) {
      return res;
    });
  }

  Future setCredential(Map<String, dynamic> data) async {
    final uri = ApiPaths.setCredentials.asUri(env.API_URL);

    return this.post(uri, data);
  }
}


